//
//  MyStyleKit.swift
//  ProjectName
//
//  Created by AuthorName on 10/10/2018.
//  Copyright © 2018 CompanyName. All rights reserved.
//
//  Generated by PaintCode
//  http://www.paintcodeapp.com
//



import UIKit

public class MyStyleKit : NSObject {

    //// Cache

    private struct Cache {
        static let iconColor: UIColor = UIColor(red: 1.000, green: 0.642, blue: 0.099, alpha: 1.000)
    }

    //// Colors

    @objc dynamic public class var iconColor: UIColor { return Cache.iconColor }

    //// Drawing Methods

    @objc dynamic public class func drawRateButton(radius: CGFloat = 10, title: String = "New Titles", pressed: Bool = true) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!

        //// Color Declarations
        let iconStrokeColor = MyStyleKit.iconColor.highlight(withLevel: 0.8)
        let color = UIColor(red: 0.500, green: 0.500, blue: 0.500, alpha: 0.402)

        //// Rectangle Drawing
        let rectangleRect = CGRect(x: 31.5, y: 19.5, width: 220, height: 54.5)
        let rectanglePath = UIBezierPath(roundedRect: rectangleRect, cornerRadius: radius)
        iconStrokeColor.setFill()
        rectanglePath.fill()
        MyStyleKit.iconColor.setStroke()
        rectanglePath.lineWidth = 3
        rectanglePath.stroke()
        let rectangleStyle = NSMutableParagraphStyle()
        rectangleStyle.alignment = .center
        let rectangleFontAttributes = [
            .font: UIFont(name: "AvenirNext-Medium", size: 26)!,
            .foregroundColor: MyStyleKit.iconColor,
            .paragraphStyle: rectangleStyle,
        ] as [NSAttributedString.Key: Any]

        let rectangleTextHeight: CGFloat = title.boundingRect(with: CGSize(width: rectangleRect.width, height: CGFloat.infinity), options: .usesLineFragmentOrigin, attributes: rectangleFontAttributes, context: nil).height
        context.saveGState()
        context.clip(to: rectangleRect)
        title.draw(in: CGRect(x: rectangleRect.minX, y: rectangleRect.minY + (rectangleRect.height - rectangleTextHeight) / 2, width: rectangleRect.width, height: rectangleTextHeight), withAttributes: rectangleFontAttributes)
        context.restoreGState()


        //// Star Drawing
        let starPath = UIBezierPath()
        starPath.move(to: CGPoint(x: 59.5, y: 33.5))
        starPath.addLine(to: CGPoint(x: 62.52, y: 42.34))
        starPath.addLine(to: CGPoint(x: 71.86, y: 42.48))
        starPath.addLine(to: CGPoint(x: 64.39, y: 48.09))
        starPath.addLine(to: CGPoint(x: 67.14, y: 57.02))
        starPath.addLine(to: CGPoint(x: 59.5, y: 51.64))
        starPath.addLine(to: CGPoint(x: 51.86, y: 57.02))
        starPath.addLine(to: CGPoint(x: 54.61, y: 48.09))
        starPath.addLine(to: CGPoint(x: 47.14, y: 42.48))
        starPath.addLine(to: CGPoint(x: 56.48, y: 42.34))
        starPath.close()
        MyStyleKit.iconColor.setFill()
        starPath.fill()
        MyStyleKit.iconColor.setStroke()
        starPath.lineWidth = 1
        starPath.stroke()


        if (pressed) {
            //// Rectangle 2 Drawing
            let rectangle2Path = UIBezierPath(roundedRect: CGRect(x: 31.5, y: 19.5, width: 220, height: 54.5), cornerRadius: radius)
            color.setFill()
            rectangle2Path.fill()
            UIColor.gray.setStroke()
            rectangle2Path.lineWidth = 3
            rectangle2Path.stroke()
        }
    }

}



private extension UIColor {
    func withHue(_ newHue: CGFloat) -> UIColor {
        var saturation: CGFloat = 1, brightness: CGFloat = 1, alpha: CGFloat = 1
        self.getHue(nil, saturation: &saturation, brightness: &brightness, alpha: &alpha)
        return UIColor(hue: newHue, saturation: saturation, brightness: brightness, alpha: alpha)
    }
    func withSaturation(_ newSaturation: CGFloat) -> UIColor {
        var hue: CGFloat = 1, brightness: CGFloat = 1, alpha: CGFloat = 1
        self.getHue(&hue, saturation: nil, brightness: &brightness, alpha: &alpha)
        return UIColor(hue: hue, saturation: newSaturation, brightness: brightness, alpha: alpha)
    }
    func withBrightness(_ newBrightness: CGFloat) -> UIColor {
        var hue: CGFloat = 1, saturation: CGFloat = 1, alpha: CGFloat = 1
        self.getHue(&hue, saturation: &saturation, brightness: nil, alpha: &alpha)
        return UIColor(hue: hue, saturation: saturation, brightness: newBrightness, alpha: alpha)
    }
    func withAlpha(_ newAlpha: CGFloat) -> UIColor {
        var hue: CGFloat = 1, saturation: CGFloat = 1, brightness: CGFloat = 1
        self.getHue(&hue, saturation: &saturation, brightness: &brightness, alpha: nil)
        return UIColor(hue: hue, saturation: saturation, brightness: brightness, alpha: newAlpha)
    }
    func highlight(withLevel highlight: CGFloat) -> UIColor {
        var red: CGFloat = 1, green: CGFloat = 1, blue: CGFloat = 1, alpha: CGFloat = 1
        self.getRed(&red, green: &green, blue: &blue, alpha: &alpha)
        return UIColor(red: red * (1-highlight) + highlight, green: green * (1-highlight) + highlight, blue: blue * (1-highlight) + highlight, alpha: alpha * (1-highlight) + highlight)
    }
    func shadow(withLevel shadow: CGFloat) -> UIColor {
        var red: CGFloat = 1, green: CGFloat = 1, blue: CGFloat = 1, alpha: CGFloat = 1
        self.getRed(&red, green: &green, blue: &blue, alpha: &alpha)
        return UIColor(red: red * (1-shadow), green: green * (1-shadow), blue: blue * (1-shadow), alpha: alpha * (1-shadow) + shadow)
    }
}
